

template <										// --- TI INA219 template										
	typename T,									// IIC template
	unsigned address							// INA219 IIC address
> struct CINA219 {								//
	T iic;										// IIC template
	CINA219(T _iic) : iic(_iic) { };			// Save IIC template in member variable
	unsigned read(unsigned n);					// Read INA219 register
	void write(unsigned reg, unsigned val);		// Write INA219 register
};
	
template <
	typename T,
	unsigned address
> unsigned CINA219<T, address>::read(unsigned reg)
{												// --- Read INA219 register
	iic.start();								// Start
	iic.write(address << 1);					// Select INA219 for write
	iic.write(reg & 0xFF);						// Select register
	iic.start();								// Start
	iic.write((address << 1) | 1);				// Select INA219 for read
	const unsigned a = iic.read();				// Read register MSB with ACK
	const unsigned b = iic.read_nak();			// Read register LSB with NAK
	iic.stop();									// Stop
	return (a << 8) | (b & 0xFF);				// Return register
}
	
template <
	typename T,
	unsigned address
> void CINA219<T, address>::write(unsigned reg, unsigned val)
{												// --- Write INA219 register
	iic.start();								// Start
	iic.write(address << 1);					// Select INA219 for write					
	iic.write(reg & 0xFF);						// Select register
	iic.write(val >> 8);						// Write MSB
	iic.write(val & 0xFF);						// Write LSB
	iic.stop();									// Stop
}
